/*
 *  $Id: comm_dup.c,v 1.6 1993/11/12 12:31:42 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/*@

MPI_Comm_dup - duplicates an existing communicator with all its cached
               information

@*/

#include <mpi.h>


int MPI_Comm_dup ( comm, comm_out )
MPI_Comm comm, *comm_out;
{
  MPI_Comm new_comm;

  /* Check for valid arguments */
  if ( comm == (MPI_Comm)0 ) {
    (*comm_out) = (MPI_Comm)0;
    return (MPI_SUCCESS);
  }
   
  new_comm                  = NEW(MPIR_COMMUNICATOR);
  new_comm->comm_type       = MPIR_INTRA;
  (void) MPIR_GROUP_dup ( comm->group, &(new_comm->group) );
  (void) MPIR_Context_alloc ( comm, 2, &(new_comm->send_context) );
  new_comm->recv_context    = new_comm->send_context;
  new_comm->comm_cache      = 0;
  new_comm->topology.type   = MPI_UNDEFINED;
  (void) MPIR_Attr_copy ( comm, new_comm ); 
  (void) MPIR_Comm_make_coll ( new_comm );
  (*comm_out)               = new_comm;

  return(MPI_SUCCESS);
}

