/*
 *  $Id: sendrecv.c,v 1.1 1993/11/24 00:47:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: sendrecv.c,v 1.1 1993/11/24 00:47:54 doss Exp $";
#endif /* lint */

#include "mpi.h"

/*@
    MPI_Sendrecv - 
@*/
int MPI_Sendrecv( send_buf, send_count, send_type, dest,
                  recv_buf, recv_count, recv_type, source,
                  tag, comm, status )
void         *send_buf;
int           send_count;
MPI_Datatype  send_type;
int           dest;
void         *recv_buf;
int           recv_count;
MPI_Datatype  recv_type;
int           source;
int           tag;
MPI_Comm      comm;
MPI_Status   *status;
{
    int               errno = MPI_SUCCESS;
    MPI_Status        status_array[2];
    MPI_Comm_request  req[2];

    /* Check for invalid arguments */
    if ( (comm == (MPI_Comm)0) )
      return (errno);

    MPI_Isend ( send_buf, send_count, send_type, dest,   tag, comm, &req[0] );
    MPI_Irecv ( recv_buf, recv_count, recv_type, source, tag, comm, &req[1] );
    MPI_Waitall ( 2, req, status_array );

    (*status) = status_array[1];
    return (errno);
}
