/*
 *  $Id: graph_nbr_cnt.c,v 1.4 1993/11/12 12:35:46 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Graph_neighbors_count - returns the number of neighbors of a node
                            associated with a graph topology

@*/
int MPI_Graph_neighbors_count ( comm, rank, nneighbors )
MPI_Comm  comm;
int               rank;
int              *nneighbors;
{
  /* Check for valid arguments */
  if ( (comm                      == (MPI_Comm)0)               ||
       (comm->topology.type       != MPI_GRAPH)                         ||
       (rank                      <  0)                                 ||
       (rank                      >= (comm->topology.tag.graph.nnodes)) ||
       (nneighbors                == (int *)0) )
    return (MPI_SUCCESS);

  /* Get nneighbors */
  if ( rank == 0 ) 
    (*nneighbors) = comm->topology.tag.graph.index[rank];
  else
    (*nneighbors) = comm->topology.tag.graph.index[rank] -
                    comm->topology.tag.graph.index[rank-1];
  
  return (MPI_SUCCESS);
}
