/*
 *  $Id: topo_status.c,v 1.3 1993/11/12 12:35:46 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Topo_status - determine the type of topology (if any) associated with a 
                  communicator

@*/
int MPI_Topo_status ( comm, status )
MPI_Comm  comm;
int              *status; 
{
  /* Check for valid arguments */
  if ( comm == (MPI_Comm)0 )
    return (MPI_SUCCESS);

  /* Set the status */
  if ( status != (int *)0 )
    (*status) = comm->topology.type;

  return (MPI_SUCCESS);
}
